class Polynomial
  attr_reader :coefs

  ##
  # Coeficients are float numbers.
  # The first coefficient is a_0
  def initialize(coefs = [])
    @coefs = coefs
  end

  def derivative
    new_coefs = @coefs.map.with_index do |element, index|
      element * index
    end
    new_coefs.shift
    Polynomial.new(new_coefs)
  end

  def to_s
    str_coefs = @coefs.map.with_index do |coef, index|
      "#{coef}*x^#{index}"
    end
    str_coefs.reverse.join(" + ")
  end

  def degree
    @coefs.size
  end

  def reverse_each
    @coefs.reverse.each
  end

  def <=>(other)
    degree_compare = degree <=> other.degree
    return degree_compare if degree_compare != 0
    our_iter = reverse_each
    other_iter = other.reverse_each
    loop do
      compare = our_iter.next <=> other_iter.next
      return compare if compare != 0
    end
    0
  end
end
