require "test_helper"

class PolynomialTest < Minitest::Test
  def test_that_derivative_works
    polynom = Polynomial.new([1, 0, 1])
    derivative = polynom.derivative
    assert_equal [0, 2], derivative.coefs
  end

  def test_that_init_works
    polynom = Polynomial.new([10, 15, 16])
    assert_equal [10, 15, 16], polynom.coefs
  end

  def test_polynom_pretty_printing
    polynom = Polynomial.new([1, 2, 3])
    assert_equal "3*x^2 + 2*x^1 + 1*x^0", polynom.to_s
  end

  def test_polynom_correctly_calculates_degree
    polynom = Polynomial.new([1, 2, 3])
    assert_equal 3, polynom.degree
  end

  def test_that_bigger_polynom_is_bigger
    big_polynom = Polynomial.new([1, 2, 3])
    small_polynom = Polynomial.new([1, 2])
    assert (big_polynom <=> small_polynom) > 0
  end

  def test_that_bigger_coef_polynom_is_bigger
    big_polynom = Polynomial.new([1, 2, 3])
    small_polynom = Polynomial.new([1, 2, 1])
    assert (big_polynom <=> small_polynom) > 0
  end

  def test_that_equal_polynoms_are_equal
    polynom = Polynomial.new([1, 2, 3])
    assert (polynom <=> polynom) == 0
  end
end
